/*
 * proiect.c
 */

#include "lcd.h"
#include <stdlib.h>
#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <stdio.h>

//function for find out the key pressed
 uint8_t GetKeyPressed()
 {
   uint8_t r,c;
   PORTB|= 0X0F;

   for(c=0;c<3;c++)
   {
	  DDRB&=~(0X7F);
	  DDRB|=(0X40>>c);
	  for(r=0;r<4;r++)
	  {
		if(!(PINB & (0X08>>r)))
		{
			return (r*3+c);
		}
	  }
   }

    return 0XFF;
 }
 
 //return the corresponding letter acording with number of pressed
 
char get_letter(int keypad, int count) {
	
	switch(keypad) {
		case 0:
			switch(count) {
				case 1:
					LCD_printAt(55, "a");
					_delay_ms(1000);
					return 'a';
				case 2:
					LCD_printAt(55, "b");
					_delay_ms(1000);
					return 'b';
				case 3:
					LCD_printAt(55, "c");
					_delay_ms(1000);
					return 'c';
			}
		case 1:
			switch(count) {
				case 1:
					LCD_printAt(55, "d");
					_delay_ms(1000);
					return 'd';
				case 2:
					LCD_printAt(55, "e");
					_delay_ms(1000);
					return 'e';
				case 3:
					LCD_printAt(55, "f");
					_delay_ms(1000);
					return 'f';
			}
		case 2:
			switch(count) {
				case 1:
					LCD_printAt(55, "g");
					_delay_ms(1000);
					return 'g';
				case 2:
					LCD_printAt(55, "h");
					_delay_ms(1000);
					return 'h';
				case 3:
					LCD_printAt(55, "i");
					_delay_ms(1000);
					return 'i';
			}
		case 3:
			switch(count) {
				case 1:
					LCD_printAt(55, "j");
					_delay_ms(1000);
					return 'j';
				case 2:
					LCD_printAt(55, "k");
					_delay_ms(1000);
					return 'k';
				case 3:
					LCD_printAt(55, "l");
					_delay_ms(1000);
					return 'l';
			}
		case 4:
			switch(count) {
				case 1:
					LCD_printAt(55, "m");
					_delay_ms(1000);
					return 'm';
				case 2:
					LCD_printAt(55, "n");
					_delay_ms(1000);
					return 'n';
				case 3:
					LCD_printAt(55, "o");
					_delay_ms(1000);
					return 'o';
			}
		case 5:
			switch(count) {
				case 1:
					LCD_printAt(55, "p");
					_delay_ms(1000);
					return 'p';
				case 2:
					LCD_printAt(55, "r");
					_delay_ms(1000);
					return 'r';
				case 3:
					LCD_printAt(55, "s");
					_delay_ms(1000);
					return 's';
			}
		case 6:
			switch(count) {
				case 1:
					LCD_printAt(55, "t");
					_delay_ms(1000);
					return 't';
				case 2:
					LCD_printAt(55, "u");
					_delay_ms(1000);
					return 'u';
				case 3:
					LCD_printAt(55, "v");
					_delay_ms(1000);
					return 'v';
			}
		case 7:
			switch(count) {
				case 1:
					LCD_printAt(55, "w");
					_delay_ms(1000);
					return 'w';
				case 2:
					LCD_printAt(55, "x");
					_delay_ms(1000);
					return 'x';
				case 3:
					LCD_printAt(55, "y");
					_delay_ms(1000);
					return 'y';
			}
	}
}

//search the letter in the word and replace the spaces
int search(char letter, char *word, char* guessed) {
	char *ret = strchr(word, letter);
	char *aux = word;
	if (ret == NULL) {
		return -1;
	}else {
		guessed[ret-aux] = letter;
		aux += ret-aux;
		ret = strchr(aux+1, letter);
		_delay_ms(500);
		guessed[ret-aux+1] = letter;
		_delay_ms(500);
		LCD_printAt(0, guessed);
		if (strcmp(word, guessed) == 0) {
			return 0;
		}
		return 1;
	}
}

//main program
int main()
{
	//vector of appearences
	int i;
	int v[8];
	for (i = 0; i < 8; i++) 
		v[i] = 0;


	//init LCD
	LCD_init();
	LCD_print("Jocul");
	LCD_printAt(40, "Spanzuratoarea");
	_delay_ms(4000);
	//_delay_ms(500);
	LCD_clear();
 
	//words list and choose a word
	char *mywords[5] = {"buton", "tastatura", "monitor", "cablu", "controller"};
	int length_words[5] = {5, 9, 7, 5, 10};
	
	//choose a word from the list
	//int index = random() % 5;
	//char *random_word = mywords[index];
	//int length_chosen = length_words[index];
	//char *random_word = (char*)malloc(7*sizeof(char));
	char random_word[7];
	strcpy(random_word,"monitor");
	int length_chosen = 7;
	
	//start the game
	LCD_print("Ghiceste");
	LCD_printAt(42, "cuvantul!");
	_delay_ms(4000);
	//_delay_ms(500);
	LCD_clear();
	LCD_print("Ai 8 vieti!");
	_delay_ms(3000);
	//_delay_ms(500);

	LCD_clear();
	
	int lives = 8;
	char *lives_string = (char*) malloc(2*sizeof(char));
	char *line = (char*) malloc(length_chosen*sizeof(char));
	for (i = 0; i < length_chosen; i++) {
		LCD_print("_");
	}
	char guessed_word[7];
	strcpy(guessed_word, "_______");
	sprintf(lives_string, "X%d", lives);
	LCD_printAt(14, lives_string);
	LCD_printAt(40, "Alege o litera: ");

	//main loop
	while(1) {			
		int x = GetKeyPressed();	
		switch(x){
			case 0:
				//LCD_printAt(55, "1");
				_delay_ms(1000);
				break;
			case 1:
				//LCD_printAt(55, "2");
				v[0]++;
				_delay_ms(1000);
				break;
			case 2:
				//LCD_printAt(55, "3");
				v[1]++;
				_delay_ms(1000);
				break;
			case 3:
				//LCD_printAt(55, "4");
				v[2]++;
				_delay_ms(1000);
				break;
			case 4:
				//LCD_printAt(55, "5");
				v[3]++;
				_delay_ms(1000);
				break;
			case 5:
				//LCD_printAt(55, "6");
				v[4]++;
				_delay_ms(1000);
				break;
			case 6:
				//LCD_printAt(55, "7");
				v[5]++;
				_delay_ms(1000);
				break;
			case 7:
				//LCD_printAt(55, "8");
				v[6]++;
				_delay_ms(1000);
				break;
			case 8:
				//LCD_printAt(55, "9");
				v[7]++;
				_delay_ms(1000);
				break;
			case 9://valid the letter
				for (i = 0; i < 8; i++) {
					if (v[i] != 0) {
						char letter = get_letter(i, v[i]);
						_delay_ms(500);
						int rez = search(letter, random_word, guessed_word);
						if (lives == 0 && rez != -1) {
							LCD_clear();
							LCD_print("Mai incearca...");
							LCD_printAt(40, "Ai pierdut!");
						}
						if (rez == 0) {
							LCD_clear();
							LCD_print("Felictari!");
							LCD_printAt(40, "Ai castigat!");
						} else if (rez == -1) {
							lives = lives - 1;
							sprintf(lives_string, "X%d", lives);
							LCD_printAt(14, lives_string);
						}
						_delay_ms(500);
						v[i] = 0;
						_delay_ms(500);
						break;
					}
				}
				//LCD_printAt(55, "*");
				break;
			case 10:
				//LCD_printAt(55, "0");
				break;
			case 11:
				//LCD_printAt(55, "#");
				break;
		}
	}
	
    return 0;
}

